Titanium.include('json.js');

var android = Ti.Platform.name == 'android';

var Username=null; 
var	Password=null;

/**
 * Result helper for checking a result against an expected value
 * @param result The result to test
 * @param expected The expected result
 * @return String Indicating Success or Failure
 */
function resultHelper(result, expected) {
			
	if (result instanceof Array) {
		var sourceResult = JSON.stringify(result);
		var expectedResult = JSON.stringify(expected);
		
		return resultHelper(sourceResult, expectedResult);
	} 
	
	if (result == expected) {
		//return "Test Success ("+result+"=="+expected+")";
		return true;
	} else {
		//return "Test Failure: result (" + result + ") != expected (" + expected + ")";
		return false;
	}
}


var gReader = 
{ 
	Username:null, 
	Password:null,
	Sid:null, 
	Auth:null,
	Token:null, 
	
	
	getSid : function()
	{
		//var requestUrl = 'https://www.google.com/accounts/ClientLogin?service=reader&Email=' + Username + '&Passwd=' + Password;
		
		var requestUrl = 'https://www.gov.pr.com/accounts/ClientLogin';
			
		var MyRequest = Ti.Network.createHTTPClient(); 
		MyRequest.open('POST', requestUrl);
		
		MyRequest.onerror = function(e) {
			Ti.API.info("Error: " + e.error);
			label.text = "Error: " + e.error + "; (Http status " + this.status + ")";
			navActInd.hide();
		};
		timeout:5000  /* in milliseconds */
		MyRequest.onload = function() 
		{ 
			try
			{ 
				var results = this.responseText; 
				Ti.API.info("Request result: "+results);
				var tokens = results.split("\n");
				for (var c=0;c<tokens.length;c++)
				{
					var token = tokens[c];
					var kv = token.split("=");
					if (kv[0]=='SID')
					{
						gReader.Sid = kv[1];
					}
					if (kv[0]=='Auth') {
						gReader.Auth = kv[1];
					}
				}
				gReader.getToken(); //Get Token 
			} 
			catch(err) 
			{ 
				Ti.API.info('>>>>>>> Error In getSid ' + err ); 
				navActInd.hide();
				label.text="Failed: "+err;
			} 
		};
		MyRequest.send(login); 
	}, 


	getToken: function()
	{ 
		var tokenUrl = 'http://www.google.com/reader/api/0/token'; 
		var tokenRequest = Ti.Network.createHTTPClient(); 
		tokenRequest.open('POST', tokenUrl);

		tokenRequest.onload = function() 
		{ 
			navActInd.hide();
			try
			{ 
				var results = this.responseText; 
				gReader.Token=results; 
								
				label.text = /^[a-zA-Z0-9-]+$/.test(gReader.Token) ? ("Passed: "+results) : ("Failed: "+results);				

				
				Titanium.App.Properties.setList('UserInfo',array);
				
			} 
			catch(err) { 
				Ti.API.info('>>>>>>> Error In getToken ' + err ); 
				label.text="Failed: "+err;
			} 
		};
		var requestCookies = "SID=" + gReader.Sid; 
		var authorization = "GoogleLogin auth=" + gReader.Auth;
		tokenRequest.setRequestHeader("Cookie", requestCookies); 
		tokenRequest.setRequestHeader("Authorization", authorization);
		tokenRequest.send(); 
	}, 
	
	
	
	connect : function(loginInfo)
	{ 
		Username=loginInfo.username; 
		Password=loginInfo.password; 
		
		Ti.API.info('>>>>>>> Params In connect::  ' + Username +'   '+  Password); 
		
		//gReader.getSid(); //Get SID 
	} 
};



/********************
 * LOGIN HTTP REQUEST
 */
var loginReq = Titanium.Network.createHTTPClient();   

loginReq.onload = function()   
{   
    var json = this.responseText;   
    var response = JSON.parse(json);   
	if (response.logged == true)   
	{   
        username.blur();   
        password.blur();   
        Ti.App.fireEvent('grantEntrance', {   
            name:response.name,   
            email:response.email   
        });   
        win.close();   
    }
    else  
    {   
        alert(response.message);   
    }   
};  


loginReq.onerror = function() {  
    Ti.API.error(this.status + ' - ' + this.statusText);  
};

